#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <sstream>
#include <fstream>
#include <time.h>
#include <ctime>
#include <string>
#include <string.h>
#include <algorithm>
using namespace std;

#define DELTA 500;

int tabu_long = 25;
float alpha1 = 0.6;
int depth = 500;
int restart_value = 600000000;

int non_drop_len;
float belta = 0.1;
int delta = DELTA;
int p;
double cutting_time = 2000;
string inFile;
int iter_mark;

clock_t startTime, endTime;
int iter;
int now_len = 0;
int best_value = 0;

double best_time;

int nonimprove_len = 0;
int nonimprove_count = 0;

int max_vtx, max_edg;
float dens;
int **edge;
int **left_unadj, **right_unadj;
int *left_unadjlen, *right_unadjlen;
int **left_unadjlen_index, **right_unadjlen_index;
int *left_clique, *right_clique;
int *left_fre, *right_fre;

int *left_clique_index, *right_clique_index;
int left_len, right_len;
int *left_flag, *right_flag;

int *left_best, *right_best;
int *left_best_flag, *right_best_flag;

int *left_nb0, *left_nb0Index;
int left_nb0Len;
int *left_nb1, *left_nb1Index;
int left_nb1Len;
int *right_nb0, *right_nb0Index;
int right_nb0Len;
int *right_nb1, *right_nb1Index;
int right_nb1Len;


int **left_mapping, **right_mapping;
int *left_mapping_len, *right_mapping_len;
int **left_mapping_index, **right_mapping_index;

int **left_dropping, **right_dropping;
int *left_dropping_len, *right_dropping_len;
int **left_dropping_index, **right_dropping_index;

int *left_tabu, *right_tabu;

int dropping_mark = -1;
int add_flag = -1;
int *candidate_add;
int candidate_len = 0;


/*function definition*/
void read_initial();
int random_int(int);
void initial_construct();
void update_add_info(int, int);
void update_add_vertex(int, int);
void update_drop_info(int, int);
void update_drop_vertex(int, int);
int compute_left_dropping();
int compute_right_dropping();
void clear_dropping_len();
int add0_flag(int);
void judge_dropping();
int judge_nonimprove();
void clear_all();
void judge_aspiration();
void release_memory();



void read_initial()
{
	ifstream FIC;
	FIC.open(inFile);
	if (FIC.fail())
	{
		cout << "### Erreur open, File_Name " << inFile << endl;
		getchar();
		exit(0);
	}
	if (FIC.eof())
	{
		cout << "### Error open, File_Name " << inFile << endl;
		getchar();
		exit(0);
	}
	FIC >> max_vtx;

	edge = new int *[max_vtx];

	left_unadj = new int *[max_vtx];
	right_unadj = new int *[max_vtx];
	left_unadjlen = new int[max_vtx];
	right_unadjlen = new int[max_vtx];
	left_unadjlen_index = new int *[max_vtx];
	right_unadjlen_index = new int *[max_vtx];

	left_clique = new int[max_vtx];
	right_clique = new int[max_vtx];
	left_fre = new int[max_vtx];
	right_fre = new int[max_vtx];

	left_clique_index = new int[max_vtx];
	right_clique_index = new int[max_vtx];
	left_flag = new int[max_vtx];
	right_flag = new int[max_vtx];

	left_best = new int[max_vtx];
	right_best = new int[max_vtx];
	left_best_flag = new int[max_vtx];
	right_best_flag = new int[max_vtx];

	left_nb0 = new int[max_vtx];
	left_nb0Index = new int[max_vtx];

	right_nb0 = new int[max_vtx];
	right_nb0Index = new int[max_vtx];

	left_dropping_len = new int[max_vtx];
	right_dropping_len = new int[max_vtx];

	left_mapping_len = new int[max_vtx];
	right_mapping_len = new int[max_vtx];

	left_tabu = new int[max_vtx];
	right_tabu = new int[max_vtx];
	candidate_add = new int[max_vtx];

	for (int x = 0; x < max_vtx; x++)
	{
		edge[x] = new int[max_vtx];
		left_unadj[x] = new int[max_vtx];
		right_unadj[x] = new int[max_vtx];
		left_unadjlen_index[x] = new int[max_vtx];
		right_unadjlen_index[x] = new int[max_vtx];

	}

	memset(left_clique, 0, sizeof(int)*max_vtx);
	memset(right_clique, 0, sizeof(int)*max_vtx);
	memset(left_best, 0, sizeof(int)*max_vtx);
	memset(right_best, 0, sizeof(int)*max_vtx);
	memset(left_flag, 0, sizeof(int)*max_vtx);
	memset(right_flag, 0, sizeof(int)*max_vtx);
	memset(left_best_flag, 0, sizeof(int)*max_vtx);
	memset(right_best_flag, 0, sizeof(int)*max_vtx);
	memset(left_dropping_len, 0, sizeof(int)*max_vtx);
	memset(right_dropping_len, 0, sizeof(int)*max_vtx);
	memset(left_mapping_len, 0, sizeof(int)*max_vtx);
	memset(right_mapping_len, 0, sizeof(int)*max_vtx);
	memset(left_tabu, 0, sizeof(int)*max_vtx);
	memset(right_tabu, 0, sizeof(int)*max_vtx);
	memset(candidate_add, 0, sizeof(int)*max_vtx);
	memset(left_unadjlen, 0, sizeof(int)*max_vtx);
	memset(right_unadjlen, 0, sizeof(int)*max_vtx);
	memset(left_fre, 0, sizeof(int)*max_vtx);
	memset(right_fre, 0, sizeof(int)*max_vtx);


	for (int x = 0; x < max_vtx; x++)
	{
		left_clique_index[x] = x;
		right_clique_index[x] = x;
		left_nb0[x] = x;
		left_nb0Index[x] = x;
		right_nb0[x] = x;
		right_nb0Index[x] = x;
		memset(edge[x], 0, sizeof(int)*max_vtx);
		memset(left_unadj[x], 0, sizeof(int)*max_vtx);
		memset(right_unadj[x], 0, sizeof(int)*max_vtx);
		memset(left_unadjlen_index[x], 0, sizeof(int)*max_vtx);
		memset(right_unadjlen_index[x], 0, sizeof(int)*max_vtx);
	}

	if (1)
	{
		for (int x = 0; x < max_vtx; x++)
		{
			for (int y = 0; y < max_vtx; y++)
			{
				FIC >> edge[x][y];
				if (edge[x][y] == 0)
				{
					left_unadj[x][left_unadjlen[x]] = y;
					right_unadj[y][right_unadjlen[y]] = x;
					left_unadjlen_index[x][y] = left_unadjlen[x];
					right_unadjlen_index[y][x] = right_unadjlen[y];
					left_unadjlen[x]++;
					right_unadjlen[y]++;
				}
			}
		}
	}
	FIC.close();

	left_len = 0;
	right_len = 0;
	left_nb0Len = max_vtx;
	right_nb0Len = max_vtx;
	left_nb1Len = 0;
	right_nb1Len = 0;
	add_flag = -1;
	dropping_mark = -1;

}

int random_int(int n)
{
	return rand() % n;
}


void initial_construct()
{
	int selV;
	int k = random_int(2);

	while (1)
	{
		if (k % 2 == 0)
		{
			if (left_nb0Len > 0)
			{
				selV = left_nb0[rand() % left_nb0Len];
				update_add_info(selV, 0);
			}
			else if (right_nb0Len == 0)
				break;
		}
		else if (k % 2 == 1)
		{
			if (right_nb0Len > 0)
			{
				selV = right_nb0[rand() % right_nb0Len];
				update_add_info(selV, 1);
			}
			else if (left_nb0Len == 0)
				break;
		}
		k++;
	}
}

void update_add_info(int bestV, int lr)
{
	int nbID, nbValue;

	if (lr == 0)
	{
		left_clique[left_len] = bestV;
		left_clique_index[bestV] = left_len;
		left_len++;
		left_flag[bestV] = 1;

		nbID = left_nb0Index[bestV];
		left_nb0Len--;
		nbValue = left_nb0[left_nb0Len];
		left_nb0[nbID] = nbValue;
		left_nb0Index[nbValue] = nbID;
	}
	else if (lr == 1)
	{
		right_clique[right_len] = bestV;
		right_clique_index[bestV] = right_len;
		right_len++;
		right_flag[bestV] = 1;

		nbID = right_nb0Index[bestV];
		right_nb0Len--;
		nbValue = right_nb0[right_nb0Len];
		right_nb0[nbID] = nbValue;
		right_nb0Index[nbValue] = nbID;
	}
	update_add_vertex(bestV, lr);
}


void update_add_vertex(int bestV, int lr)
{
	int nbID, nbValue, tempID, tempValue, temp_drop;
	int x, y;

	if (lr == 0)
	{
		for (int i = 0; i < left_unadjlen[bestV]; i++)
		{
			y = left_unadj[bestV][i];
			right_mapping_len[y]++;

			if (right_mapping_len[y] == 1)
			{
				nbID = right_nb0Index[y];
				right_nb0Len--;
				nbValue = right_nb0[right_nb0Len];
				right_nb0[nbID] = nbValue;
				right_nb0Index[nbValue] = nbID;
			}
		}
	}
	else if (lr == 1)
	{
		for (int i = 0; i < right_unadjlen[bestV]; i++)
		{
			x = right_unadj[bestV][i];
			left_mapping_len[x]++;

			if (left_mapping_len[x] == 1)
			{
				nbID = left_nb0Index[x];
				left_nb0Len--;
				nbValue = left_nb0[left_nb0Len];
				left_nb0[nbID] = nbValue;

				left_nb0Index[nbValue] = nbID;
			}
		}
	}
}

void update_drop_info(int bestV, int lr)/
{
	int nbID, nbValue, temp_ID, temp_Value;

	if (lr == 0)
	{
		temp_ID = left_clique_index[bestV];
		left_len--;
		temp_Value = left_clique[left_len];
		left_clique[temp_ID] = temp_Value;
		left_clique_index[temp_Value] = temp_ID;
		left_flag[bestV] = 0;
	
		left_nb0[left_nb0Len] = bestV;
		left_nb0Index[bestV] = left_nb0Len;
		left_nb0Len++;
	}
	else if (lr == 1)
	{
		temp_ID = right_clique_index[bestV];
		right_len--;
		temp_Value = right_clique[right_len];
		right_clique[temp_ID] = temp_Value;
		right_clique_index[temp_Value] = temp_ID;
		right_flag[bestV] = 0;
	
		right_nb0[right_nb0Len] = bestV;
		right_nb0Index[bestV] = right_nb0Len;
		right_nb0Len++;
	}

	update_drop_vertex(bestV, lr);
}

void update_drop_vertex(int bestV, int lr)
{
	int nbID, nbValue, tempID, tempValue;
	int x, y;

	if (lr == 0)
	{
		for (int i = 0; i < left_unadjlen[bestV]; i++)
		{
			y = left_unadj[bestV][i];
			right_mapping_len[y]--;

			if (right_mapping_len[y] == 0)
			{
				right_nb0[right_nb0Len] = y;
				right_nb0Index[y] = right_nb0Len;
				right_nb0Len++;
			}
		}
	}
	else if (lr == 1)
	{
		for (int i = 0; i < right_unadjlen[bestV]; i++)
		{
			y = right_unadj[bestV][i];
			left_mapping_len[y]--;

			if (left_mapping_len[y] == 0)
			{
				left_nb0[left_nb0Len] = y;
				left_nb0Index[y] = left_nb0Len;
				left_nb0Len++;
			}
		}
	}
}

int compute_left_dropping()
{
	int tempID, tempVALUE, temp = 0;
	for (int i = 0; i < left_len; i++)
	{
		tempID = left_clique[i];
		if (left_tabu[tempID] <= iter)
		{
			for (int j = 0; j < left_unadjlen[tempID]; j++)
			{
				tempVALUE = left_unadj[tempID][j];
				if (right_mapping_len[tempVALUE] == 1 && right_tabu[tempVALUE] <= iter)
				{
					left_dropping_len[tempID]++;
				}
			}
			if (left_dropping_len[tempID] > temp)
			{
				temp = left_dropping_len[tempID];
				dropping_mark = tempID;
			}
		}
		else
		{
			for (int j = 0; j < left_unadjlen[tempID]; j++)
			{
				tempVALUE = left_unadj[tempID][j];
				if (right_mapping_len[tempVALUE] == 1 && right_tabu[tempVALUE] <= iter)
				{
					left_dropping_len[tempID]++;
				}
			}
			if ((min((right_len + right_nb0Len), left_len - 1) > best_value))// && left_dropping_len[tempID] > temp)
			{
				temp = left_dropping_len[tempID];
				dropping_mark = tempID;
			}
		}
	}
	return dropping_mark;

}

int compute_right_dropping()
{
	int tempID, tempVALUE, temp = 0;
	for (int i = 0; i < right_len; i++)
	{
		tempID = right_clique[i];
		if (right_tabu[tempID] <= iter)
		{
			for (int j = 0; j < right_unadjlen[tempID]; j++)
			{
				tempVALUE = right_unadj[tempID][j];
				if (left_mapping_len[tempVALUE] == 1 && left_tabu[tempVALUE] <= iter)
				{
					right_dropping_len[tempID]++;
				}
			}
			if (right_dropping_len[tempID] > temp)
			{
				temp = right_dropping_len[tempID];
				dropping_mark = tempID;
			}
		}
		else
		{
			for (int j = 0; j < right_unadjlen[tempID]; j++)
			{
				tempVALUE = right_unadj[tempID][j];
				if (left_mapping_len[tempVALUE] == 1 && left_tabu[tempVALUE] <= iter)
				{
					right_dropping_len[tempID]++;
				}
			}
			if ((min((left_len + left_nb0Len), right_len - 1) > best_value))//&& right_dropping_len[tempID] > temp)
			{
				temp = right_dropping_len[tempID];
				dropping_mark = tempID;
			}
		}
	}
	return dropping_mark;

}

void clear_dropping_len()
{

	if (delta < 200)
	{
		delta = 200;
	}
	else if (delta > 800)
	{
		delta = 800;
	}

	for (int i = 0; i < max_vtx; i++)
	{
		left_dropping_len[i] = 0;
		right_dropping_len[i] = 0;
	}
	dropping_mark = -1;
	add_flag = -1;
	candidate_len = 0;
}

int add0_flag(int lr)
{
	int tempID, tempVALUE;

	if (lr == 0)
	{
		if (left_nb0Len == 0)
		{
			add_flag = -1;
			return add_flag;
		}
		else
		{
			for (int i = 0; i < left_nb0Len; i++)
			{
				tempID = left_nb0[i];
				if (left_tabu[tempID] <= iter)
				{
					add_flag = tempID;
					return tempID;
				}
			}
		}
	}
	else if (lr == 1)
	{
		if (right_nb0Len == 0)
		{
			add_flag = -1;
			return add_flag;
		}
		else
		{
			for (int i = 0; i < right_nb0Len; i++)
			{
				tempID = right_nb0[i];
				if (right_tabu[tempID] <= iter)
				{
					add_flag = tempID;
					return tempID;
				}
			}

		}
	}
	return add_flag;
}



void tabu_search()
{
	int temp_add, temp_drop, temp_len, temp_delta, temp_equal;

	while ((double)((endTime - startTime) / CLOCKS_PER_SEC) < cutting_time)
	{

		if (nonimprove_count >= restart_value)
		{
			clear_all();
			initial_construct();
			nonimprove_count = 0;
			cout << "restart  iter: " << iter << endl;
		}
		if (left_len < right_len)
		{
			add0_flag(0);
			compute_right_dropping();
			if (add_flag != -1 && dropping_mark != -1)
			{
				p = random_int(1000);
				if (p < delta)
				{
					temp_len = left_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = left_nb0[i];
						if (left_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 0);
							left_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
					}
					if (judge_nonimprove())
					{
						delta += 10;
					}
				}
				else
				{
					update_drop_info(dropping_mark, 1);
					right_tabu[dropping_mark] = iter + tabu_long;
					temp_len = left_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = left_nb0[i];
						if (left_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 0);
							left_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}
			}
			else if (dropping_mark != -1)
			{
				update_drop_info(dropping_mark, 1);
				right_tabu[dropping_mark] = iter + tabu_long;
				temp_len = left_nb0Len;
				for (int i = 0; i < temp_len; i++)
				{
					temp_add = left_nb0[i];
					if (left_tabu[temp_add] <= iter)
					{
						update_add_info(temp_add, 0);
						left_tabu[temp_add] = iter + alpha1 * tabu_long;
					}
				}
				if (judge_nonimprove())
				{
					delta -= 10;
				}
			}
			else if (add_flag == -1 && dropping_mark == -1)
			{
				dropping_mark = right_clique[random_int(right_len)];
				update_drop_info(dropping_mark, 1);
			}

		}
		else if (left_len > right_len)
		{
			add0_flag(1);
			compute_left_dropping();
			if (add_flag != -1 && dropping_mark != -1)
			{
				p = random_int(1000);
				if (p < delta)
				{
					temp_len = right_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = right_nb0[i];
						if (right_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 1);
							right_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
						else
							continue;
					}
					if (judge_nonimprove())
					{
						delta += 10;
					}
				}
				else
				{
					update_drop_info(dropping_mark, 0);
					left_tabu[dropping_mark] = iter + tabu_long;
					temp_len = right_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = right_nb0[i];
						if (right_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 1);
							right_tabu[temp_add] = iter + tabu_long;
						}
						else
							continue;
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}
				
			}
			else if (dropping_mark != -1)
			{
				update_drop_info(dropping_mark, 0);
				left_tabu[dropping_mark] = iter + tabu_long;
				temp_len = right_nb0Len;
				for (int i = 0; i < temp_len; i++)
				{
					temp_add = right_nb0[i];
					if (right_tabu[temp_add] <= iter)
					{
						update_add_info(temp_add, 1);
						right_tabu[temp_add] = iter + tabu_long;
					}
					else
						continue;
				}
				if (judge_nonimprove())
				{
					delta -= 10;
				}
			}
			else if (add_flag == -1 && dropping_mark == -1)
			{
				dropping_mark = left_clique[random_int(left_len)];
				update_drop_info(dropping_mark, 0);
			}
		}
		else if (left_len == right_len)
		{
			temp_equal = random_int(2);
			if (temp_equal == 0)
			{
				add0_flag(0);
				compute_right_dropping();
				if (add_flag != -1 && dropping_mark != -1)
				{
					p = random_int(1000);
					if (p < delta)
					{
						temp_len = left_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = left_nb0[i];
							if (left_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 0);
								left_tabu[temp_add] = iter + alpha1 * tabu_long;
							}
						}
						if (judge_nonimprove())
						{
							delta += 10;
						}
					}
					else
					{
						update_drop_info(dropping_mark, 1);
						right_tabu[dropping_mark] = iter + tabu_long;
						temp_len = left_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = left_nb0[i];
							if (left_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 0);
								left_tabu[temp_add] = iter + alpha1 * tabu_long;
							}
						}
						if (judge_nonimprove())
						{
							delta -= 10;
						}
					}
				}
				else if (dropping_mark != -1)
				{
					update_drop_info(dropping_mark, 1);
					right_tabu[dropping_mark] = iter + tabu_long;
					temp_len = left_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = left_nb0[i];
						if (left_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 0);
							left_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}
				else if (add_flag == -1 && dropping_mark == -1)
				{
					dropping_mark = right_clique[random_int(right_len)];
					update_drop_info(dropping_mark, 1);
				}


			}
			else if (temp_equal == 1)
			{
				add0_flag(1);
				compute_left_dropping();
				if (add_flag != -1 && dropping_mark != -1)
				{
					p = random_int(1000);
					if (p < delta)
					{
						temp_len = right_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = right_nb0[i];
							if (right_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 1);
								right_tabu[temp_add] = iter + alpha1 * tabu_long;
							}
							else
								continue;
						}
						if (judge_nonimprove())
						{
							delta += 10;
						}
					}
					else
					{
						update_drop_info(dropping_mark, 0);
						left_tabu[dropping_mark] = iter + tabu_long;
						temp_len = right_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = right_nb0[i];
							if (right_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 1);
								right_tabu[temp_add] = iter + tabu_long;
							}
							else
								continue;
						}
						if (judge_nonimprove())
						{
							delta -= 10;
						}
					}
				}
				else if (dropping_mark != -1)
				{
					update_drop_info(dropping_mark, 0);
					left_tabu[dropping_mark] = iter + tabu_long;
					temp_len = right_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = right_nb0[i];
						if (right_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 1);
							right_tabu[temp_add] = iter + tabu_long;
						}
						else
							continue;
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}
				else if (add_flag == -1 && dropping_mark == -1)
				{
					dropping_mark = left_clique[random_int(left_len)];
					update_drop_info(dropping_mark, 0);
				}
			}

		}

		//judge_nonimprove();
		judge_aspiration();
		judge_dropping();
		//cout << "iter: " << iter << ", left len: " << left_len << ", right len: " << right_len << ", nonimprove: " << nonimprove_len << ", best value: " << best_value << endl;
		clear_dropping_len();
		iter++;
		endTime = clock();
		tabu_long = min(25, (int)(0.2 * best_value + 0.1*random_int(best_value)));
		//cout << "delta: " << delta << endl;
	}
}

void judge_aspiration()
{
	int temp_add, temp_len;
	if (left_len - right_len > 0)
	{
		if ((right_nb0Len > 0) && (min((right_len + right_nb0Len), left_len) > best_value))
		{
			iter_mark = iter;
			nonimprove_len = 0;
			nonimprove_count = 0;
			temp_len = right_nb0Len;
			for (int i = 0; i < temp_len; i++)
			{
				temp_add = right_nb0[i];
				update_add_info(temp_add, 1);
				right_tabu[temp_add] = iter + alpha1 * tabu_long;
			}
			endTime = clock();
			best_time = (double)(endTime - startTime) / CLOCKS_PER_SEC;
			best_value = min((right_len + right_nb0Len), left_len);
			cout<< "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
		}
	}
	else if (left_len - right_len < 0)
	{
		if ((left_nb0Len > 0) && (min((left_len + left_nb0Len), right_len) > best_value))
		{
			iter_mark = iter;
			nonimprove_len = 0;
			nonimprove_count = 0;
			temp_len = left_nb0Len;
			for (int i = 0; i < temp_len; i++)
			{
				temp_add = left_nb0[i];
				update_add_info(temp_add, 0);
				left_tabu[temp_add] = iter + alpha1 * tabu_long;
			}
			endTime = clock();
			best_time = (double)(endTime - startTime) / CLOCKS_PER_SEC;
			best_value = min((left_len + left_nb0Len), right_len);
			cout << "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
		}
	}
}

void judge_dropping()
{

	if (nonimprove_len >= depth)
	{

		non_drop_len = belta * best_value;
		for (int i = 0; i < non_drop_len; i++)
		{
			dropping_mark = left_clique[random_int(left_len)];
			update_drop_info(dropping_mark, 0);
			left_tabu[dropping_mark] = iter + tabu_long;

			dropping_mark = right_clique[random_int(right_len)];
			update_drop_info(dropping_mark, 1);
			right_tabu[dropping_mark] = iter + tabu_long;
		}
		for (int i = 0; i < (non_drop_len / 2); i++)
		{
			left_tabu[random_int(max_vtx)] = 0;
			right_tabu[random_int(max_vtx)] = 0;
		}
		nonimprove_len = 0;
		nonimprove_count++;
		delta = DELTA;
	}
}

int judge_nonimprove()
{
	if (left_len > right_len)
	{
		now_len = right_len;
		if (now_len > best_value)
		{
			iter_mark = iter;
			nonimprove_count = 0;
			nonimprove_len = 0;
			best_value = now_len;
			endTime = clock();
			best_time = (double)(endTime - startTime) / CLOCKS_PER_SEC;
			//cout << "iter: " << iter << ", left len: " << left_len << ", right len: " << right_len << ", best value: " << best_value << endl;
			cout << "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
			for (int i = 0; i < left_len; i++)
			{
				left_best[i] = left_clique[i];
			}
			for (int i = 0; i < right_len; i++)
			{
				right_best[i] = right_clique[i];
			}
			return 1;
		}
		else
		{
			nonimprove_len++;
			return 0;
		}
			
	}
	else
	{
		now_len = left_len;
		if (now_len > best_value)
		{
			iter_mark = iter;
			nonimprove_len = 0;
			nonimprove_count = 0;
			best_value = now_len;
			endTime = clock();
			best_time = (double)(endTime - startTime) / CLOCKS_PER_SEC;
			//cout << "iter: " << iter << ", left len: " << left_len << ", right len: " << right_len << ", best value: " << best_value << endl;
			cout << "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
			for (int i = 0; i < left_len; i++)
			{
				left_best[i] = left_clique[i];
			}
			for (int i = 0; i < right_len; i++)
			{
				right_best[i] = right_clique[i];
			}
		}
		else
		{
			nonimprove_len++;
			return 0;
		}
	}
}

void clear_all()
{
	memset(left_clique, 0, sizeof(int)*max_vtx);
	memset(right_clique, 0, sizeof(int)*max_vtx);
	memset(left_best, 0, sizeof(int)*max_vtx);
	memset(right_best, 0, sizeof(int)*max_vtx);
	memset(left_flag, 0, sizeof(int)*max_vtx);
	memset(right_flag, 0, sizeof(int)*max_vtx);
	memset(left_best_flag, 0, sizeof(int)*max_vtx);
	memset(right_best_flag, 0, sizeof(int)*max_vtx);
	memset(left_dropping_len, 0, sizeof(int)*max_vtx);
	memset(right_dropping_len, 0, sizeof(int)*max_vtx);
	memset(left_mapping_len, 0, sizeof(int)*max_vtx);
	memset(right_mapping_len, 0, sizeof(int)*max_vtx);
	memset(left_tabu, 0, sizeof(int)*max_vtx);
	memset(right_tabu, 0, sizeof(int)*max_vtx);
	memset(candidate_add, 0, sizeof(int)*max_vtx);

	for (int x = 0; x < max_vtx; x++)
	{
		left_clique_index[x] = x;
		right_clique_index[x] = x;
		left_nb0[x] = x;
		left_nb0Index[x] = x;
		right_nb0[x] = x;
		right_nb0Index[x] = x;

	}


	left_len = 0;
	right_len = 0;
	left_nb0Len = max_vtx;
	right_nb0Len = max_vtx;
	left_nb1Len = 0;
	right_nb1Len = 0;
	add_flag = -1;
	dropping_mark = -1;
	nonimprove_len = 0;


}

void release_memory()
{
	for (int x = 0; x < max_vtx; x++)
	{
		delete[]edge[x];
		delete[]left_unadj[x];
		delete[]right_unadj[x];
		delete[]left_unadjlen_index[x];
		delete[]right_unadjlen_index[x];
	}

	delete[]left_unadjlen;
	delete[]right_unadjlen;
	delete[]left_clique;
	delete[]right_clique;
	delete[]left_best;
	delete[]right_best;
	delete[]left_clique_index;
	delete[]right_clique_index;
	delete[]left_flag;
	delete[]right_flag;
	delete[]left_nb0;
	delete[]left_nb0Index;
	delete[]right_nb0;
	delete[]right_nb0Index;
	delete[]left_dropping_len;
	delete[]right_dropping_len;
	delete[]left_mapping_len;
	delete[]right_mapping_len;

}

int main(int argc, char **argv)
{
	if (argc == 4)
	{
		inFile = argv[1];
		depth = atoi(argv[2]);
		cutting_time = atoi(argv[3]);
	}	
	else
	{
		cout << "Error : the user should input four parameters to run the program." << endl;
		getchar();
		exit(0);
	}

	ofstream fout("mbbp_dense.txt", ios::app);
	if (!fout)
	{
		cout << "can not open output file" << endl;
		return 1;
	}
	
	string *file_array = new string[60];

	file_array[0] = "output-GraphU_1000_0.05_1.txt", file_array[1] = "output-GraphU_1000_0.05_2.txt", file_array[2] = "output-GraphU_1000_0.05_3.txt";
	file_array[3] = "output-GraphU_1000_0.05_4.txt", file_array[4] = "output-GraphU_1000_0.05_5.txt";

	file_array[5] = "output-GraphU_1000_0.10_1.txt", file_array[6] = "output-GraphU_1000_0.10_2.txt", file_array[7] = "output-GraphU_1000_0.10_3.txt";
	file_array[8] = "output-GraphU_1000_0.10_4.txt", file_array[9] = "output-GraphU_1000_0.10_5.txt";

	file_array[10] = "output-GraphU_1000_0.15_1.txt", file_array[11] = "output-GraphU_1000_0.15_2.txt", file_array[12] = "output-GraphU_1000_0.15_3.txt";
	file_array[13] = "output-GraphU_1000_0.15_4.txt", file_array[14] = "output-GraphU_1000_0.15_5.txt";

	file_array[15] = "output-GraphU_5000_0.05_1.txt", file_array[16] = "output-GraphU_5000_0.05_2.txt", file_array[17] = "output-GraphU_5000_0.05_3.txt";
	file_array[18] = "output-GraphU_5000_0.05_4.txt", file_array[19] = "output-GraphU_5000_0.05_5.txt";

	file_array[20] = "output-GraphU_5000_0.10_1.txt", file_array[21] = "output-GraphU_5000_0.10_2.txt", file_array[22] = "output-GraphU_5000_0.10_3.txt";
	file_array[23] = "output-GraphU_5000_0.10_4.txt", file_array[24] = "output-GraphU_5000_0.10_5.txt";

	file_array[25] = "output-GraphU_5000_0.15_1.txt", file_array[26] = "output-GraphU_5000_0.15_2.txt", file_array[27] = "output-GraphU_5000_0.15_3.txt";
	file_array[28] = "output-GraphU_5000_0.15_4.txt", file_array[29] = "output-GraphU_5000_0.15_5.txt";

	file_array[30] = "GraphU_250_0.05_1.txt", file_array[31] = "GraphU_250_0.05_2.txt", file_array[32] = "GraphU_250_0.05_3.txt";
	file_array[33] = "GraphU_250_0.05_4.txt", file_array[34] = "GraphU_250_0.05_5.txt";

	file_array[35] = "GraphU_250_0.10_1.txt", file_array[36] = "GraphU_250_0.10_2.txt", file_array[37] = "GraphU_250_0.10_3.txt";
	file_array[38] = "GraphU_250_0.10_4.txt", file_array[39] = "GraphU_250_0.10_5.txt";

	file_array[40] = "GraphU_250_0.15_1.txt", file_array[41] = "GraphU_250_0.15_2.txt", file_array[42] = "GraphU_250_0.15_3.txt";
	file_array[43] = "GraphU_250_0.15_4.txt", file_array[44] = "GraphU_250_0.15_5.txt";

	file_array[45] = "GraphU_500_0.05_1.txt", file_array[46] = "GraphU_500_0.05_2.txt", file_array[47] = "GraphU_500_0.05_3.txt";
	file_array[48] = "GraphU_500_0.05_4.txt", file_array[49] = "GraphU_500_0.05_5.txt";

	file_array[50] = "GraphU_500_0.10_1.txt", file_array[51] = "GraphU_500_0.10_2.txt", file_array[52] = "GraphU_500_0.10_3.txt";
	file_array[53] = "GraphU_500_0.10_4.txt", file_array[54] = "GraphU_500_0.10_5.txt";

	file_array[55] = "GraphU_500_0.15_1.txt", file_array[56] = "GraphU_500_0.15_2.txt", file_array[57] = "GraphU_500_0.15_3.txt";
	file_array[58] = "GraphU_500_0.15_4.txt", file_array[59] = "GraphU_500_0.15_5.txt";

	srand((unsigned)time(NULL));

	read_initial();

	startTime = clock();
	endTime = startTime;
	initial_construct();


	tabu_search();

	fout << inFile << "	" << best_value << "	" << best_time << "	" << iter_mark << endl;
	
	clear_all();

	release_memory();

	fout.close();
	getchar();
	return 0;
}
