#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <sstream>
#include <fstream>
#include <time.h>
#include <ctime>
#include <string.h>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;
#define MAX_VAL 999999;
#define DELTA 500;
int DIFF = 5;
int delta = 500;


int tabu_long = 10;
float alpha1 = 0.6;
int depth = 100;
int restart_value = 600000000;
int is_random;

int non_drop_len;
float belta = 1;
double cutting_time = 1000;
string inFile;
int iter_mark;

clock_t startTime, endTime;
int iter;
int now_len = 0;
int best_value = 0;
int left_crt_min_deg = 999999;
int right_crt_min_deg = 999999;

double best_time;

int nonimprove_len = 0;
int nonimprove_count = 0;

int max_vtx, max_edg;
int left_crt_max_vtx, right_crt_max_vtx;
int left_org_max_vtx, right_org_max_vtx;

float dens;
int tempEdge;

vector<int>left_vtx_2_peel, right_vtx_2_peel;
int* left_crt_v_org_id;
int* right_crt_v_org_id;

int *left_clique, *right_clique;

int** left_crt_adj;
int* left_crt_adjlen;
int** right_crt_adj;
int* right_crt_adjlen;
int** left_org_adj;
int* left_org_adjlen;
int** right_org_adj;
int* right_org_adjlen;
int crt_min_deg;
int aspira_flag;



int *left_clique_index, *right_clique_index;
int left_len, right_len;
int *left_flag, *right_flag;

int *left_best, *right_best;
int *left_best_flag, *right_best_flag;

int *left_nb0, *left_nb0Index;
int left_nb0Len;
int *left_nb1, *left_nb1Index;
int left_nb1Len;
int *right_nb0, *right_nb0Index;
int right_nb0Len;
int *right_nb1, *right_nb1Index;
int right_nb1Len;

int *left_nb0_flag;
int *right_nb0_flag;

int *left_nb1_flag;
int *right_nb1_flag;


int **left_mapping, **right_mapping;
int *left_mapping_len, *right_mapping_len;
int **left_mapping_index, **right_mapping_index;

int **left_dropping, **right_dropping;
int *left_dropping_len, *right_dropping_len;
int *left_dropping_len1, *right_dropping_len1;
int **left_dropping_index, **right_dropping_index;

int *left_tabu, *right_tabu;

int dropping_mark = -1;
int add_flag = -1;
int candidate_len = 0;

int* left_crt_v_edges_count;
int* right_crt_v_edges_count;

void find_peel_vertices(int, vector<int>&);
void report_best();

int left_min, right_min;

class Cedge
{
public:
	int v1;
	int v2;
};

Cedge *edge;


void read_initial(string);
int random_int(int);
void initial_construct();
void update_add_info(int, int);
void update_add_vertex(int, int);
void update_drop_info(int, int);
void update_drop_vertex(int, int);
int judge_nonimprove();
int check_solution();
void report_solution();
void reduce_and_rebuild();
void judge_aspiration();


void read_initial(string inFile)
{
	ifstream FIC;
	FIC.open(inFile);
	if (FIC.fail())
	{
		cout << "### Error open, File_Name " << inFile << endl;
		getchar();
		exit(0);
	}
	if (FIC.eof())
	{
		cout << "### Error open, File_Name " << inFile << endl;
		getchar();
		exit(0);
	}
	FIC >> left_crt_max_vtx >> right_crt_max_vtx >> max_edg;
	cout << left_crt_max_vtx << ", " << right_crt_max_vtx << ", " << max_edg << endl;
	left_clique = new int[left_crt_max_vtx];
	right_clique = new int[right_crt_max_vtx];

	left_clique_index = new int[left_crt_max_vtx];
	right_clique_index = new int[right_crt_max_vtx];
	left_flag = new int[left_crt_max_vtx];
	right_flag = new int[right_crt_max_vtx];

	left_nb0_flag = new int[left_crt_max_vtx];
	right_nb0_flag = new int[right_crt_max_vtx];

	left_nb1_flag = new int[left_crt_max_vtx];
	right_nb1_flag = new int[right_crt_max_vtx];

	left_best = new int[left_crt_max_vtx];
	right_best = new int[right_crt_max_vtx];
	left_best_flag = new int[left_crt_max_vtx];
	right_best_flag = new int[right_crt_max_vtx];

	left_nb0 = new int[left_crt_max_vtx];
	left_nb0Index = new int[left_crt_max_vtx];

	left_nb1 = new int[left_crt_max_vtx];
	left_nb1Index = new int[left_crt_max_vtx];

	right_nb0 = new int[right_crt_max_vtx];
	right_nb0Index = new int[right_crt_max_vtx];

	right_nb1 = new int[right_crt_max_vtx];
	right_nb1Index = new int[right_crt_max_vtx];

	left_dropping_len = new int[left_crt_max_vtx];
	right_dropping_len = new int[right_crt_max_vtx];

	left_mapping_len = new int[left_crt_max_vtx];
	right_mapping_len = new int[right_crt_max_vtx];

	left_tabu = new int[left_crt_max_vtx];
	right_tabu = new int[right_crt_max_vtx];

	memset(left_clique, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_best, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_best_flag, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_flag, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_nb1_flag, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_dropping_len, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_mapping_len, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_tabu, 0, sizeof(int)*left_crt_max_vtx);

	memset(right_clique, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_best, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_best_flag, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_flag, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_nb1_flag, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_dropping_len, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_mapping_len, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_tabu, 0, sizeof(int)*right_crt_max_vtx);

	for (int x = 0; x < left_crt_max_vtx; x++)
	{
		left_clique_index[x] = x;
		left_nb0[x] = x;
		left_nb0Index[x] = x;
		left_nb1[x] = 0;
		left_nb1Index[x] = 0;
		left_nb0_flag[x] = 1;

	}
	for (int x = 0; x < right_crt_max_vtx; x++)
	{
		right_clique_index[x] = x;
		right_nb0[x] = x;
		right_nb0Index[x] = x;
		right_nb1[x] = 0;
		right_nb1Index[x] = 0;
		right_nb0_flag[x] = 1;
	}

	//cout << max_edg;
	//cout << left_crt_max_vtx << right_crt_max_vtx << endl;
	left_crt_adj = new int*[left_crt_max_vtx];
	right_crt_adj = new int*[right_crt_max_vtx];

	edge = new Cedge[max_edg];

	left_crt_v_org_id = new int[left_crt_max_vtx];
	right_crt_v_org_id = new int[right_crt_max_vtx];
	for (int i = 0; i < left_crt_max_vtx; i++) {
		left_crt_v_org_id[i] = i;
	}
	for (int i = 0; i < right_crt_max_vtx; i++) {
		right_crt_v_org_id[i] = i;
	}
	/*read edges*/
	left_crt_v_edges_count = new int[left_crt_max_vtx];
	right_crt_v_edges_count = new int[right_crt_max_vtx];
	memset(left_crt_v_edges_count, 0, sizeof(int) * left_crt_max_vtx);
	memset(right_crt_v_edges_count, 0, sizeof(int) * right_crt_max_vtx);
	cout << "begin read ";
	for (int i = 0; i < max_edg; i++)
	{
		int a, b;
		FIC >> a >> b;
		//cout << a << ", " << b << endl;
		a--;
		b--;
		edge[i].v1 = a;
		edge[i].v2 = b;
		left_crt_v_edges_count[a]++;
		right_crt_v_edges_count[b]++;
	}
	cout << "end read" << endl;

	for (int i = 0; i < left_crt_max_vtx; i++)
	{
		left_crt_adj[i] = new int[left_crt_v_edges_count[i]];
	}
	for (int i = 0; i < right_crt_max_vtx; i++)
	{
		right_crt_adj[i] = new int[right_crt_v_edges_count[i]];

	}

	left_crt_adjlen = new int[left_crt_max_vtx];
	right_crt_adjlen = new int[right_crt_max_vtx];
	memset(left_crt_adjlen, 0, sizeof(int) * left_crt_max_vtx);
	memset(right_crt_adjlen, 0, sizeof(int) * right_crt_max_vtx);

	int k1, k2;
	for (int i = 0; i < max_edg; i++)
	{
		k1 = edge[i].v1;
		k2 = edge[i].v2;
		left_crt_adj[k1][left_crt_adjlen[k1]++] = k2;
		right_crt_adj[k2][right_crt_adjlen[k2]++] = k1;

	}
	crt_min_deg = MAX_VAL;
	left_crt_min_deg = MAX_VAL;
	right_crt_min_deg = MAX_VAL;

	for (int i = 0; i < left_crt_max_vtx; i++)
	{
		sort(left_crt_adj[i], left_crt_adj[i] + left_crt_adjlen[i]);
		if (left_crt_adjlen[i] < left_crt_min_deg)
		{
			left_crt_min_deg = left_crt_adjlen[i];
			left_min = i;
		}
	}
	for (int i = 0; i < right_crt_max_vtx; i++)
	{
		sort(right_crt_adj[i], right_crt_adj[i] + right_crt_adjlen[i]);
		if (right_crt_adjlen[i] < right_crt_min_deg)
		{
			right_crt_min_deg = right_crt_adjlen[i];
			right_min = i;
		}
	}
	crt_min_deg = min(left_crt_min_deg, right_crt_min_deg);

	left_nb0Len = left_crt_max_vtx;
	right_nb0Len = right_crt_max_vtx;
	left_nb1Len = 0;
	right_nb1Len = 0;


	/*reserve the orignial graph for verification*/
	left_org_adjlen = new int[left_crt_max_vtx];
	memcpy(left_org_adjlen, left_crt_adjlen, sizeof(int) * left_crt_max_vtx);
	left_org_adj = new int*[left_crt_max_vtx];
	for (int i = 0; i < left_crt_max_vtx; i++)
	{
		left_org_adj[i] = new int[left_org_adjlen[i]];
		memcpy(left_org_adj[i], left_crt_adj[i], sizeof(int) * left_org_adjlen[i]);
	}
	right_org_adjlen = new int[right_crt_max_vtx];
	memcpy(right_org_adjlen, right_crt_adjlen, sizeof(int) * right_crt_max_vtx);
	right_org_adj = new int*[right_crt_max_vtx];
	for (int i = 0; i < right_crt_max_vtx; i++)
	{
		right_org_adj[i] = new int[right_org_adjlen[i]];
		memcpy(right_org_adj[i], right_crt_adj[i], sizeof(int) * right_org_adjlen[i]);
	}

}


int random_int(int n)
{
	return rand() % n;
}

void find_peel_vertices(int reduce_deg, vector<int>& left_vtx_2_peel, vector<int>& right_vtx_2_peel)
{
	int *left_reduced_edge_count = new int[left_crt_max_vtx];
	int *right_reduced_edge_count = new int[right_crt_max_vtx];

	int *left_mark = new int[left_crt_max_vtx];
	int *right_mark = new int[right_crt_max_vtx];

	memset(left_mark, 0, sizeof(int) * left_crt_max_vtx);
	memset(right_mark, 0, sizeof(int) * right_crt_max_vtx);

	memcpy(left_reduced_edge_count, left_crt_adjlen, sizeof(int) * left_crt_max_vtx);
	memcpy(right_reduced_edge_count, right_crt_adjlen, sizeof(int) * right_crt_max_vtx);

	queue<int> left_rm_que;
	queue<int> right_rm_que;
	if (reduce_deg >= crt_min_deg)
	{
		for (int idx = 0; idx < left_crt_max_vtx; idx++)
		{
			if (left_reduced_edge_count[idx] <= reduce_deg)
			{
				left_rm_que.push(idx);
				left_mark[idx] = 1;
			}
		}
		for (int idx = 0; idx < right_crt_max_vtx; idx++)
		{
			if (right_reduced_edge_count[idx] <= reduce_deg)
			{
				right_rm_que.push(idx);
				right_mark[idx] = 1;
			}
		}
		while (!left_rm_que.empty() || !right_rm_que.empty())
		{
			while (!left_rm_que.empty())
			{
				int idx = left_rm_que.front();
				left_rm_que.pop();
				left_vtx_2_peel.push_back(idx);
				for (int i = 0; i < left_crt_adjlen[idx]; i++)
				{
					int adjv = left_crt_adj[idx][i];
					right_reduced_edge_count[adjv]--;
					if (!right_mark[adjv] && right_reduced_edge_count[adjv] <= reduce_deg)
					{
						right_mark[adjv] = 1;
						right_rm_que.push(adjv);
					}
				}
			}
			while (!right_rm_que.empty())
			{
				int idx = right_rm_que.front();
				right_rm_que.pop();
				right_vtx_2_peel.push_back(idx);
				for (int i = 0; i < right_crt_adjlen[idx]; i++)
				{
					int adjv = right_crt_adj[idx][i];
					left_reduced_edge_count[adjv]--;
					if (!left_mark[adjv] && left_reduced_edge_count[adjv] <= reduce_deg)
					{
						left_mark[adjv] = 1;
						left_rm_que.push(adjv);
					}
				}
			}
		}
	}
	delete[] left_reduced_edge_count;
	delete[] right_reduced_edge_count;
	delete[] left_mark;
	delete[] right_mark;
}

void rebuild_rest_graph(vector<int> &left_rm_vertices, vector<int> &right_rm_vertices)
{
	/*Mark the vertices to be removed*/
	int *left_rmflag = new int[left_crt_max_vtx];
	int *right_rmflag = new int[right_crt_max_vtx];
	/*The left adjacent edges after reduce*/
	//int *reduced_edge_count = new int[num_sum_ve];
	//memcpy(reduced_edge_count, v_edges_count, sizeof(int) * num_sum_ve);
	memset(left_rmflag, 0, sizeof(int) * left_crt_max_vtx);
	memset(right_rmflag, 0, sizeof(int) * right_crt_max_vtx);
	for (int i = 0; i < left_rm_vertices.size(); i++) 
	{
		int v = left_rm_vertices[i];
		left_rmflag[v] = 1;
	}
	for (int i = 0; i < right_rm_vertices.size(); i++)
	{
		int v = right_rm_vertices[i];
		right_rmflag[v] = 1;
	}
	int left_num_rest_ve = left_crt_max_vtx - left_rm_vertices.size();
	int right_num_rest_ve = right_crt_max_vtx - right_rm_vertices.size();
	//cout << left_num_rest_ve << ", " << right_num_rest_ve << endl;
	int *left_new_id = new int[left_crt_max_vtx]; // resign
	int *left_org_id = new int[left_crt_max_vtx];
	int *right_new_id = new int[right_crt_max_vtx]; // resign
	int *right_org_id = new int[right_crt_max_vtx];
	int left_count = 0;	//count the rest vertices
	int right_count = 0;
	//resign id to the rest vertices
	for (int idx = 0; idx < left_crt_max_vtx; idx++)
	{
		if (!left_rmflag[idx])
		{
			left_new_id[idx] = left_count;
			left_org_id[left_count] = left_crt_v_org_id[idx]; //the id in original graph, not the current graph
			left_count++;
		}
	}
	for (int idx = 0; idx < right_crt_max_vtx; idx++)
	{
		if (!right_rmflag[idx])
		{
			right_new_id[idx] = right_count;
			right_org_id[right_count] = right_crt_v_org_id[idx]; //the id in original graph, not the current graph
			right_count++;
		}
	}
	//cout << left_count << ", " << right_count << endl;
	int left_n_edges = 0;
	int **left_new_adj_tbl = new int*[left_num_rest_ve];
	int *left_new_edge_count = new int[left_num_rest_ve];
	int right_n_edges = 0;
	int **right_new_adj_tbl = new int*[right_num_rest_ve];
	int *right_new_edge_count = new int[right_num_rest_ve];
	crt_min_deg = MAX_VAL;	//recaclculate minimum degree
	for (int idx_prev = 0; idx_prev < left_crt_max_vtx; idx_prev++)
	{
		if (left_rmflag[idx_prev])
		{
			delete[] left_crt_adj[idx_prev];
			continue;
		}
		int idx_new = left_new_id[idx_prev];
		vector<int> left_rest_edges;
		//cout << "idx_prev: " << idx_prev << endl;
		for (int i = 0; i < left_crt_adjlen[idx_prev]; i++)
		{
			int vi_adj = left_crt_adj[idx_prev][i];
			//cout << "vi_adj: " << vi_adj << endl;
			if (!right_rmflag[vi_adj])
			{
				left_rest_edges.push_back(right_new_id[vi_adj]);
				left_n_edges++;
			}
		}
		left_new_edge_count[idx_new] = left_rest_edges.size();
		left_new_adj_tbl[idx_new] = new int[left_rest_edges.size()];
		copy(left_rest_edges.begin(), left_rest_edges.end(), left_new_adj_tbl[idx_new]);
		if (left_new_edge_count[idx_new] < crt_min_deg)
		{
			crt_min_deg = left_new_edge_count[idx_new];
		}
		//cout<<"left_new_edge_count[idx_new]: " << left_new_edge_count[idx_new] << endl;
		//		for (int i = 0; i < rest_edges.size(); i++){
		//			new_adj_tbl[idx_new][i] = rest_edges[i];
		//		}
		delete[] left_crt_adj[idx_prev];
	}



	for (int idx_prev = 0; idx_prev < right_crt_max_vtx; idx_prev++)
	{
		if (right_rmflag[idx_prev])
		{
			delete[] right_crt_adj[idx_prev];
			continue;
		}
		int idx_new = right_new_id[idx_prev];
		vector<int> right_rest_edges;
		for (int i = 0; i < right_crt_adjlen[idx_prev]; i++)
		{
			int vi_adj = right_crt_adj[idx_prev][i];
			//cout << "vi_adj: " << vi_adj << endl;
			if (!left_rmflag[vi_adj])
			{
				right_rest_edges.push_back(left_new_id[vi_adj]);
				right_n_edges++;
			}
		}
		right_new_edge_count[idx_new] = right_rest_edges.size();
		right_new_adj_tbl[idx_new] = new int[right_rest_edges.size()];
		copy(right_rest_edges.begin(), right_rest_edges.end(), right_new_adj_tbl[idx_new]);
		if (right_new_edge_count[idx_new] < crt_min_deg)
		{
			crt_min_deg = right_new_edge_count[idx_new];
		}
		//		for (int i = 0; i < rest_edges.size(); i++){
		//			new_adj_tbl[idx_new][i] = rest_edges[i];
		//		}
		delete[] right_crt_adj[idx_prev];
	}


	/*assign to the new graph*/
	delete[] left_crt_adj;
	left_crt_adj = left_new_adj_tbl;
	delete[] left_crt_adjlen;
	left_crt_adjlen = left_new_edge_count;

	left_crt_max_vtx = left_num_rest_ve;

	delete[] left_crt_v_org_id;
	left_crt_v_org_id = left_org_id;


	delete[] right_crt_adj;
	right_crt_adj = right_new_adj_tbl;
	delete[] right_crt_adjlen;
	right_crt_adjlen = right_new_edge_count;

	right_crt_max_vtx = right_num_rest_ve;

	delete[] right_crt_v_org_id;
	right_crt_v_org_id = right_org_id;

	delete[] left_new_id;
	delete[] left_rmflag;
	delete[] right_new_id;
	delete[] right_rmflag;

	//ݽṹ
	delete[] left_clique;
	delete[] left_best_flag;
	delete[] left_flag;
	delete[] left_nb1_flag;
	delete[] left_dropping_len;
	delete[] left_mapping_len;
	delete[] left_tabu;
	delete[] left_clique_index;
	delete[] left_nb0;
	delete[] left_nb0Index;
	delete[] left_nb1;
	delete[] left_nb1Index;
	delete[] left_nb0_flag;

	left_clique = new int[left_crt_max_vtx];
	left_best_flag = new int[left_crt_max_vtx];
	left_flag = new int[left_crt_max_vtx];
	left_nb1_flag = new int[left_crt_max_vtx];
	left_dropping_len = new int[left_crt_max_vtx];
	left_mapping_len = new int[left_crt_max_vtx];
	left_tabu = new int[left_crt_max_vtx];
	left_clique_index = new int[left_crt_max_vtx];
	left_nb0 = new int[left_crt_max_vtx];
	left_nb0Index = new int[left_crt_max_vtx];
	left_nb1 = new int[left_crt_max_vtx];
	left_nb1Index = new int[left_crt_max_vtx];
	left_nb0_flag = new int[left_crt_max_vtx];

	delete[] right_clique;
	delete[] right_best_flag;
	delete[] right_flag;
	delete[] right_nb1_flag;
	delete[] right_dropping_len;
	delete[] right_mapping_len;
	delete[] right_tabu;
	delete[] right_clique_index;
	delete[] right_nb0;
	delete[] right_nb0Index;
	delete[] right_nb1;
	delete[] right_nb1Index;
	delete[] right_nb0_flag;

	right_clique = new int[right_crt_max_vtx];
	right_best_flag = new int[right_crt_max_vtx];
	right_flag = new int[right_crt_max_vtx];
	right_nb1_flag = new int[right_crt_max_vtx];
	right_dropping_len = new int[right_crt_max_vtx];
	right_mapping_len = new int[right_crt_max_vtx];
	right_tabu = new int[right_crt_max_vtx];
	right_clique_index = new int[right_crt_max_vtx];
	right_nb0 = new int[right_crt_max_vtx];
	right_nb0Index = new int[right_crt_max_vtx];
	right_nb1 = new int[right_crt_max_vtx];
	right_nb1Index = new int[right_crt_max_vtx];
	right_nb0_flag = new int[right_crt_max_vtx];


	memset(left_clique, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_best_flag, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_flag, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_nb1_flag, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_dropping_len, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_mapping_len, 0, sizeof(int)*left_crt_max_vtx);
	memset(left_tabu, 0, sizeof(int)*left_crt_max_vtx);

	memset(right_clique, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_best_flag, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_flag, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_nb1_flag, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_dropping_len, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_mapping_len, 0, sizeof(int)*right_crt_max_vtx);
	memset(right_tabu, 0, sizeof(int)*right_crt_max_vtx);

	for (int x = 0; x < left_crt_max_vtx; x++)
	{
		left_clique_index[x] = x;
		left_nb0[x] = x;
		left_nb0Index[x] = x;
		left_nb1[x] = 0;
		left_nb1Index[x] = 0;
		left_nb0_flag[x] = 1;

	}
	for (int x = 0; x < right_crt_max_vtx; x++)
	{
		right_clique_index[x] = x;
		right_nb0[x] = x;
		right_nb0Index[x] = x;
		right_nb1[x] = 0;
		right_nb1Index[x] = 0;
		right_nb0_flag[x] = 1;
	}

	left_nb0Len = left_crt_max_vtx;
	right_nb0Len = right_crt_max_vtx;
	left_nb1Len = 0;
	right_nb1Len = 0;
	left_len = 0;
	right_len = 0;

}
void initial_construct()
{
	int selV;
	int k = clock();

	while (1)
	{
		//cout << "k%2= " << k % 2 << endl;
		if (k % 2)
		{
			if (left_nb0Len > 0)
			{
				selV = left_nb0[rand() % left_nb0Len];
				update_add_info(selV, 0);
			}
			else if (right_nb0Len == 0)
				break;
			//cout << "left add: " << selV << endl;
		}
		else
		{
			//cout << "right_nb0Len: " << right_nb0Len << endl;
			if (right_nb0Len > 0)
			{

				selV = right_nb0[rand() % right_nb0Len];
				update_add_info(selV, 1);

			}
			else if (left_nb0Len == 0)
				break;
			//cout << "right add: " << selV << endl;

		}
		k++;

		judge_nonimprove();
		if (left_len - right_len > DIFF || right_len - left_len > DIFF)
			break;
	}
}

void update_add_info(int bestV, int lr)//lr:01
{
	int nbID, nbValue;

	if (lr == 0)
	{
		left_clique[left_len] = bestV;
		left_clique_index[bestV] = left_len;
		left_len++;
		left_flag[bestV] = 1;
		nbID = left_nb0Index[bestV];
		left_nb0Len--;
		left_nb0_flag[bestV] = 0;
		nbValue = left_nb0[left_nb0Len];
		left_nb0[nbID] = nbValue;
		left_nb0Index[nbValue] = nbID;
	}
	else if (lr == 1)
	{
		right_clique[right_len] = bestV;
		right_clique_index[bestV] = right_len;
		right_len++;
		right_flag[bestV] = 1;
		nbID = right_nb0Index[bestV];
		right_nb0Len--;
		right_nb0_flag[bestV] = 0;
		nbValue = right_nb0[right_nb0Len];
		right_nb0[nbID] = nbValue;
		right_nb0Index[nbValue] = nbID;
	}
	update_add_vertex(bestV, lr);
}

void update_add_vertex(int bestV, int lr)
{
	int nbID, nbValue, tempID, tempValue, temp_drop;
	int x, adjID;

	if (lr == 0)
	{
		for (int i = 0; i < left_crt_adjlen[bestV]; i++)
		{
			adjID = left_crt_adj[bestV][i];
			//cout << adjID << endl;
			right_mapping_len[adjID]++;

		}
		for (int i = 0; i < right_crt_max_vtx; i++)
		{

			if (right_nb0_flag[i] == 1 && right_mapping_len[i] == (left_len - 1))
			{
				nbID = right_nb0Index[i];
				right_nb0Len--;
				right_nb0_flag[i] = 0;
				nbValue = right_nb0[right_nb0Len];
				right_nb0[nbID] = nbValue;
				right_nb0Index[nbValue] = nbID;

				right_nb1_flag[i] = 1;
				right_nb1[right_nb1Len] = i;
				right_nb1Index[i] = right_nb1Len;
				right_nb1Len++;
			}
			else if (right_nb1_flag[i] == 1 && right_mapping_len[i] < (left_len - 1))
			{
				nbID = right_nb1Index[i];
				right_nb1Len--;
				right_nb1_flag[i] = 0;
				nbValue = right_nb1[right_nb1Len];
				right_nb1[nbID] = nbValue;
				right_nb1Index[nbValue] = nbID;
			}
		}


	}
	else if (lr == 1)
	{
		for (int i = 0; i < right_crt_adjlen[bestV]; i++)
		{
			adjID = right_crt_adj[bestV][i];
			left_mapping_len[adjID]++;

		}
		for (int i = 0; i < left_crt_max_vtx; i++)
		{
			if (left_nb0_flag[i] == 1 && left_mapping_len[i] == (right_len - 1))
			{
				nbID = left_nb0Index[i];
				left_nb0Len--;
				left_nb0_flag[i] = 0;
				nbValue = left_nb0[left_nb0Len];
				left_nb0[nbID] = nbValue;
				left_nb0Index[nbValue] = nbID;

				left_nb1_flag[i] = 1;
				//cout << "left_nb1Len: " << left_nb1Len << endl;
				left_nb1[left_nb1Len] = i;
				left_nb1Index[i] = left_nb1Len;
				left_nb1Len++;
			}
			else if (left_nb1_flag[i] == 1 && left_mapping_len[i] < (right_len - 1))
			{
				nbID = left_nb1Index[i];
				left_nb1Len--;
				left_nb1_flag[i] = 0;
				nbValue = left_nb1[left_nb1Len];
				left_nb1[nbID] = nbValue;
				left_nb1Index[nbValue] = nbID;
			}
		}
	}
}

void update_drop_info(int bestV, int lr)
{
	int nbID, nbValue, temp_ID, temp_Value;

	if (lr == 0)
	{
		temp_ID = left_clique_index[bestV];
		left_len--;
		temp_Value = left_clique[left_len];
		left_clique[temp_ID] = temp_Value;
		left_clique_index[temp_Value] = temp_ID;
		left_flag[bestV] = 0;
		
		left_nb0[left_nb0Len] = bestV;
		left_nb0Index[bestV] = left_nb0Len;
		left_nb0Len++;
		left_nb0_flag[bestV] = 1;
	}
	else if (lr == 1)
	{
		temp_ID = right_clique_index[bestV];
		right_len--;
		temp_Value = right_clique[right_len];
		right_clique[temp_ID] = temp_Value;
		right_clique_index[temp_Value] = temp_ID;
		right_flag[bestV] = 0;
		
		right_nb0[right_nb0Len] = bestV;
		right_nb0Index[bestV] = right_nb0Len;
		right_nb0Len++;
		right_nb0_flag[bestV] = 1;
	}

	update_drop_vertex(bestV, lr);
}

void update_drop_vertex(int bestV, int lr)
{
	int nbID, nbValue, tempID, tempValue;
	int x, adjID;

	if (lr == 0)
	{
		for (int i = 0; i < left_crt_adjlen[bestV]; i++)
		{
			adjID = left_crt_adj[bestV][i];
			
			right_mapping_len[adjID]--;
		}
		for (int i = 0; i < right_crt_max_vtx; i++)
		{
			if (right_nb1_flag[i] == 1 && right_mapping_len[i] == left_len)
			{
				nbID = right_nb1Index[i];
				right_nb1Len--;
				right_nb1_flag[i] = 0;
				nbValue = right_nb1[right_nb1Len];
				right_nb1[nbID] = nbValue;
				//cout << "i: " << i << ", nbID: " << nbID << ", right_nb1Len: " << right_nb1Len << ", nbValue: " << nbValue << endl;
				right_nb1Index[nbValue] = nbID;

				right_nb0[right_nb0Len] = i;
				right_nb0Index[i] = right_nb0Len;
				right_nb0Len++;
				right_nb0_flag[i] = 1;

			}
			else if (right_nb1_flag[i] == 0 && right_mapping_len[i] == (left_len - 1))
			{
				if (right_nb1Len < 0 || right_nb1Len>right_crt_max_vtx)
				{
					cout << "right_nb1Len: " << right_nb1Len << endl;
				}
				right_nb1[right_nb1Len] = i;
				right_nb1Index[i] = right_nb1Len;
				right_nb1Len++;
				right_nb1_flag[i] = 1;
			}

		}
	}
	else if (lr == 1)
	{
		for (int i = 0; i < right_crt_adjlen[bestV]; i++)
		{
			adjID = right_crt_adj[bestV][i];
			
			left_mapping_len[adjID]--;
		}
		for (int i = 0; i < left_crt_max_vtx; i++)
		{
			if (left_nb1_flag[i] == 1 && left_mapping_len[i] == right_len)
			{
				nbID = left_nb1Index[i];
				left_nb1Len--;
				left_nb1_flag[i] = 0;
				nbValue = left_nb1[left_nb1Len];
				left_nb1[nbID] = nbValue;
				left_nb1Index[nbValue] = nbID;

				left_nb0[left_nb0Len] = i;
				left_nb0Index[i] = left_nb0Len;
				left_nb0Len++;
				left_nb0_flag[i] = 1;

			}
			else if (left_nb1_flag[i] == 0 && left_mapping_len[i] == (right_len - 1))
			{
				if (left_nb1Len < 0 || left_nb1Len>left_crt_max_vtx)
				{
					cout << "left_nb1Len: " << left_nb1Len << endl;
				}
				left_nb1[left_nb1Len] = i;
				left_nb1Index[i] = left_nb1Len;
				left_nb1Len++;
				left_nb1_flag[i] = 1;

			}

		}
	}
}
int select_right_swap()
{
	int tempID, orgID, tempVALUE, orgVALUE, temp = 0, temp1 = 0, dropping_mark1 = -1, add0 = 0;
	int flag0 = 0, flag1 = 0;
	dropping_mark = -1;
	aspira_flag = 0;
	for (int i = 0; i < left_nb1Len; i++)
	{
		tempID = left_nb1[i];
		orgID = left_crt_v_org_id[tempID];
		if (left_tabu[tempID] <= iter)
		{
			for (int j = 0; j < right_len; j++)
			{
				tempVALUE = right_clique[j];
				orgVALUE = right_crt_v_org_id[tempVALUE];
				//cout << "( " << orgID << ", " << orgVALUE << " ) " << binary_search(left_crt_adj[orgID], left_crt_adj[orgID] + left_crt_adjlen[orgID], orgVALUE)<< endl;
				if (!binary_search(left_org_adj[orgID], left_org_adj[orgID] + left_org_adjlen[orgID], orgVALUE))
				{
					if (right_tabu[tempVALUE] <= iter)
					{
						right_dropping_len[tempVALUE]++;
						break;
					}
				}
			}

			if (right_dropping_len[tempVALUE] > temp)
			{
				temp = right_dropping_len[tempVALUE];
				dropping_mark = tempVALUE;
			}
			else if (right_dropping_len[tempVALUE] == temp)
			{
				if (random_int(2))
					dropping_mark = tempVALUE;
			}
		}
		else
			continue;
	}


	if (temp > 0)
		return temp;
	else if (temp == 0)
		return -1;
}

int select_left_swap()
{
	int tempID, orgID, tempVALUE, orgVALUE, temp = 0, temp1 = 0, dropping_mark1 = -1, add0 = 0;
	int flag0 = 0, flag1 = 0;
	dropping_mark = -1;
	aspira_flag = 0;
	for (int i = 0; i < right_nb1Len; i++)
	{
		tempID = right_nb1[i];
		orgID = right_crt_v_org_id[tempID];

		//cout << tempID<<", "<< orgID << endl;
		if (right_tabu[tempID] <= iter)
		{
			for (int j = 0; j < left_len; j++)
			{
				tempVALUE = left_clique[j];
				orgVALUE = left_crt_v_org_id[tempVALUE];
				//cout << tempVALUE << ", " << orgVALUE << endl;
				if (!binary_search(right_org_adj[orgID], right_org_adj[orgID] + right_org_adjlen[orgID], orgVALUE))
				{
					if (left_tabu[tempVALUE] <= iter)
					{
						left_dropping_len[tempVALUE]++;
						break;
					}
				}
			}

			if (left_dropping_len[tempVALUE] > temp)
			{
				temp = left_dropping_len[tempVALUE];
				dropping_mark = tempVALUE;
			}
			else if (left_dropping_len[tempVALUE] == temp)
			{
				if (random_int(2))
					dropping_mark = tempVALUE;
			}

		}
		else
			continue;
	}

	if (temp > 0)
		return temp;
	else if (temp == 0)
		return -1;
}

int select_left_add()
{
	int temp_add, count = 0;
	if (left_nb0Len > 0)
	{
		for (int i = 0; i < left_nb0Len; i++)
		{
			temp_add = left_nb0[i];
			if (left_tabu[temp_add] <= iter)
				return 1;
		}

	}
	return -1;
}

int select_right_add()
{
	int temp_add, count = 0;
	if (right_nb0Len > 0)
	{
		for (int i = 0; i < right_nb0Len; i++)
		{
			temp_add = right_nb0[i];
			if (right_tabu[temp_add] <= iter)
				return 1;
		}
	}
	return -1;
}

int judge_nonimprove()
{
	judge_aspiration();
	
	if (left_len > right_len)
	{
		now_len = right_len;
		if (now_len > best_value)
		{
			iter_mark = iter;
			nonimprove_count = 0;
			nonimprove_len = 0;
			best_value = now_len;
			endTime = clock();
			best_time = (double)(endTime - startTime) / CLOCKS_PER_SEC;
			//cout << "iter: " << iter << ", left len: " << left_len << ", right len: " << right_len << ", best value: " << best_value << endl;
			cout << "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
			for (int i = 0; i < left_len; i++)
			{
				left_best[i] = left_crt_v_org_id[left_clique[i]];
			}
			for (int i = 0; i < right_len; i++)
			{
				right_best[i] = right_crt_v_org_id[right_clique[i]];
			}
			//report_best();
			reduce_and_rebuild();
			return 1;
		}
		else
		{
			nonimprove_len++;
			return 0;
		}

	}
	else
	{
		now_len = left_len;
		if (now_len > best_value)
		{
			iter_mark = iter;
			nonimprove_len = 0;
			nonimprove_count = 0;
			best_value = now_len;
			endTime = clock();
			best_time = (double)(endTime - startTime) / CLOCKS_PER_SEC;
			//cout << "iter: " << iter << ", left len: " << left_len << ", right len: " << right_len << ", best value: " << best_value << endl;
			cout << "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
			for (int i = 0; i < left_len; i++)
			{
				left_best[i] = left_crt_v_org_id[left_clique[i]];
			}
			for (int i = 0; i < right_len; i++)
			{
				right_best[i] = right_crt_v_org_id[right_clique[i]];
			}
			//report_best();
			reduce_and_rebuild();
			return 1;

		}
		else
		{
			nonimprove_len++;
			return 0;
		}
	}
}

void judge_aspiration()
{
	int temp_add, temp_len;
	if (left_len - right_len > 0)
	{
		if ((right_nb0Len > 0) && (min((right_len + right_nb0Len), left_len) > best_value))
		{
			iter_mark = iter;
			nonimprove_len = 0;
			nonimprove_count = 0;
			temp_len = right_nb0Len;
			for (int i = 0; i < temp_len; i++)
			{
				temp_add = right_nb0[i];
				update_add_info(temp_add, 1);
				right_tabu[temp_add] = iter + alpha1 * tabu_long;
			}
			// << "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
		}
	}
	else if (left_len - right_len < 0)
	{
		if ((left_nb0Len > 0) && (min((left_len + left_nb0Len), right_len) > best_value))
		{
			iter_mark = iter;
			nonimprove_len = 0;
			nonimprove_count = 0;
			temp_len = left_nb0Len;
			for (int i = 0; i < temp_len; i++)
			{
				temp_add = left_nb0[i];
				update_add_info(temp_add, 0);
				left_tabu[temp_add] = iter + alpha1 * tabu_long;
			}

			//cout << "iter: " << iter << ", best value: " << best_value << ", The run time is: " << best_time << "s" << endl;
		}
	}
}

void judge_dropping()
{
	
	if (nonimprove_len >= depth)
	{

		non_drop_len = belta * best_value;
		for (int i = 0; i < non_drop_len; i++)
		{
			if (left_len > 0)
			{
				dropping_mark = left_clique[random_int(left_len)];
				update_drop_info(dropping_mark, 0);
				left_tabu[dropping_mark] = iter + tabu_long;
			}
			if (right_len > 0)
			{
				dropping_mark = right_clique[random_int(right_len)];
				update_drop_info(dropping_mark, 1);
				right_tabu[dropping_mark] = iter + tabu_long;
			}
		}
		for (int i = 0; i < (non_drop_len / 2); i++)
		{
			if (left_len && right_len)
			{
				left_tabu[random_int(left_len)] = 0;
				right_tabu[random_int(right_len)] = 0;
			}

		}
		nonimprove_len = 0;
		nonimprove_count++;
		delta = DELTA;
	}
}

void clear_dropping_len()
{

	if (delta < 200)
	{
		delta = 200;
	}
	else if (delta > 800)
	{
		delta = 800;
	}
	memset(left_dropping_len, 0, sizeof(int)*left_crt_max_vtx);
	memset(right_dropping_len, 0, sizeof(int)*right_crt_max_vtx);

	dropping_mark = -1;
	add_flag = -1;
	candidate_len = 0;
}

void tabu_search()
{
	int temp_add, temp_drop, temp_len, temp_delta, temp_equal, am, am1, p;

	initial_construct();
	while ((double)((endTime - startTime) / CLOCKS_PER_SEC) < cutting_time)
	{
		if (left_crt_max_vtx <= best_value || right_crt_max_vtx <= best_value)
			break;
		
		//report_solution();

		if (left_len < right_len)
		{
			am = select_left_add();
			am1 = select_right_swap();
			//cout << "am: " << am << ", am1: " << am1 <<", droppingmark: "<<dropping_mark<< endl;

			if (am != -1 && am1 != -1)
			{
				p = random_int(1000);
				if (p < delta)
				{
					temp_len = left_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = left_nb0[i];
						if (left_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 0);
							left_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
						if (left_len - right_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta += 10;
					}
				}
				else
				{
					update_drop_info(dropping_mark, 1);
					right_tabu[dropping_mark] = iter + tabu_long;
					temp_len = left_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = left_nb0[i];
						if (left_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 0);
							left_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
						if (left_len - right_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}
			}
			else if (am1 != -1)
			{
				update_drop_info(dropping_mark, 1);
				right_tabu[dropping_mark] = iter + tabu_long;
				temp_len = left_nb0Len;
				for (int i = 0; i < temp_len; i++)
				{
					temp_add = left_nb0[i];
					if (left_tabu[temp_add] <= iter)
					{
						update_add_info(temp_add, 0);
						left_tabu[temp_add] = iter + alpha1 * tabu_long;
					}
					if (left_len - right_len > DIFF)
						break;
				}
				if (judge_nonimprove())
				{
					delta -= 10;
				}
			}
			else if (am != -1)
			{
				temp_len = left_nb0Len;
				for (int i = 0; i < temp_len; i++)
				{
					temp_add = left_nb0[i];
					if (left_tabu[temp_add] <= iter)
					{
						update_add_info(temp_add, 0);
						left_tabu[temp_add] = iter + alpha1 * tabu_long;
					}
					if (left_len - right_len > DIFF)
						break;
				}
				if (judge_nonimprove())
				{
					delta += 10;
				}
			}
			else if (am == -1 && am1 == -1)
			{
				dropping_mark = right_clique[random_int(right_len)];
				update_drop_info(dropping_mark, 1);
			}

		}
		else if (left_len > right_len)
		{
			am = select_right_add();
			am1 = select_left_swap();
			//cout << "am: " << am << ", am1: " << am1 << ", droppingmark: " << dropping_mark << endl;
			if (am != -1 && am1 != -1)
			{
				p = random_int(1000);
				if (p < delta)
				{
					temp_len = right_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = right_nb0[i];
						if (right_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 1);
							right_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
						if (right_len - left_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta += 10;
					}
				}
				else
				{
					update_drop_info(dropping_mark, 0);
					left_tabu[dropping_mark] = iter + tabu_long;
					temp_len = right_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = right_nb0[i];
						if (right_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 1);
							right_tabu[temp_add] = iter + tabu_long;
						}
						if (right_len - left_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}

			}
			else if (am1 != -1)
			{
				update_drop_info(dropping_mark, 0);
				left_tabu[dropping_mark] = iter + tabu_long;
				temp_len = right_nb0Len;
				for (int i = 0; i < temp_len; i++)
				{
					temp_add = right_nb0[i];
					if (right_tabu[temp_add] <= iter)
					{
						update_add_info(temp_add, 1);
						right_tabu[temp_add] = iter + tabu_long;
					}
					if (right_len - left_len > DIFF)
						break;
				}
				if (judge_nonimprove())
				{
					delta -= 10;
				}
			}
			else if (am != -1)
			{
				temp_len = right_nb0Len;
				for (int i = 0; i < temp_len; i++)
				{
					temp_add = right_nb0[i];
					if (right_tabu[temp_add] <= iter)
					{
						update_add_info(temp_add, 1);
						right_tabu[temp_add] = iter + alpha1 * tabu_long;
					}
					if (right_len - left_len > DIFF)
						break;
				}
				if (judge_nonimprove())
				{
					delta += 10;
				}
			}
			else if (am == -1 && am1 == -1)
			{
				dropping_mark = left_clique[random_int(left_len)];
				//cout << "drop: " << dropping_mark << endl;
				update_drop_info(dropping_mark, 0);
			}
		}
		else if (left_len == right_len)
		{
			temp_equal = random_int(2);
			if (temp_equal == 0)
			{
				am = select_left_add();
				am1 = select_right_swap();
				//cout << "am: " << am << ", am1: " << am1  <<", droppingmark: " << dropping_mark << endl;

				if (am != -1 && am1 != -1)
				{
					p = random_int(1000);
					if (p < delta)
					{
						temp_len = left_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = left_nb0[i];
							if (left_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 0);
								left_tabu[temp_add] = iter + alpha1 * tabu_long;
							}
							if (left_len - right_len > DIFF)
								break;
						}
						if (judge_nonimprove())
						{
							delta += 10;
						}
					}
					else
					{
						update_drop_info(dropping_mark, 1);
						right_tabu[dropping_mark] = iter + tabu_long;
						temp_len = left_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = left_nb0[i];
							if (left_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 0);
								left_tabu[temp_add] = iter + alpha1 * tabu_long;
							}
							if (left_len - right_len > DIFF)
								break;
						}
						if (judge_nonimprove())
						{
							delta -= 10;
						}
					}
				}
				else if (am1 != -1)
				{
					update_drop_info(dropping_mark, 1);
					right_tabu[dropping_mark] = iter + tabu_long;
					temp_len = left_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = left_nb0[i];
						if (left_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 0);
							left_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
						if (left_len - right_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}
				else if (am != -1)
				{
					temp_len = left_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = left_nb0[i];
						if (left_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 0);
							left_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
						if (left_len - right_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta += 10;
					}
				}
				else if (am == -1 && am1 == -1)
				{
					dropping_mark = right_clique[random_int(right_len)];
					update_drop_info(dropping_mark, 1);
				}


			}
			else if (temp_equal == 1)
			{
				am = select_right_add();
				am1 = select_left_swap();
				//cout << "am: " << am << ", am1: " << am1 << ", droppingmark: " << dropping_mark << endl;

				if (am != -1 && am1 != -1)
				{
					p = random_int(1000);
					if (p < delta)
					{
						temp_len = right_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = right_nb0[i];
							if (right_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 1);
								right_tabu[temp_add] = iter + alpha1 * tabu_long;
							}
							if (right_len - left_len > DIFF)
								break;
						}
						if (judge_nonimprove())
						{
							delta += 10;
						}
					}
					else
					{
						update_drop_info(dropping_mark, 0);
						left_tabu[dropping_mark] = iter + tabu_long;
						temp_len = right_nb0Len;
						for (int i = 0; i < temp_len; i++)
						{
							temp_add = right_nb0[i];
							if (right_tabu[temp_add] <= iter)
							{
								update_add_info(temp_add, 1);
								right_tabu[temp_add] = iter + tabu_long;
							}
							if (right_len - left_len > DIFF)
								break;
						}
						if (judge_nonimprove())
						{
							delta -= 10;
						}
					}

				}
				else if (am1 != -1)
				{
					update_drop_info(dropping_mark, 0);
					left_tabu[dropping_mark] = iter + tabu_long;
					temp_len = right_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = right_nb0[i];
						if (right_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 1);
							right_tabu[temp_add] = iter + tabu_long;
						}
						if (right_len - left_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta -= 10;
					}
				}
				else if (am != -1)
				{
					temp_len = right_nb0Len;
					for (int i = 0; i < temp_len; i++)
					{
						temp_add = right_nb0[i];
						if (right_tabu[temp_add] <= iter)
						{
							update_add_info(temp_add, 1);
							right_tabu[temp_add] = iter + alpha1 * tabu_long;
						}
						if (right_len - left_len > DIFF)
							break;
					}
					if (judge_nonimprove())
					{
						delta += 10;
					}
				}
				else if (am == -1 && am1 == -1)
				{
					dropping_mark = left_clique[random_int(left_len)];
					update_drop_info(dropping_mark, 0);
				}
			}

		}

	
		judge_dropping();
		//cout << "iter: " << iter << ", left len: " << left_len << ", right len: " << right_len << ", nonimprove: " << nonimprove_len << ", best value: " << best_value << endl;
		clear_dropping_len();
		iter++;
		endTime = clock();

	}
}

int check_solution()
{
	int left_temp, right_temp, x;
	for (int i = 0; i < best_value; i++)
	{
		left_temp = left_crt_v_org_id[left_best[i]];
		for (int i = 0; i < best_value; i++)
		{
			right_temp = right_crt_v_org_id[right_best[i]];
			x = binary_search(left_org_adj[left_temp], left_org_adj[left_temp] + left_org_adjlen[left_temp], right_temp);
			if (!x)
				return 0;
		}
	}
	return 1;
}



void report_solution()
{
	cout << "current biclique: " << endl;
	for (int i = 0; i < left_len; i++)
	{
		cout << left_clique[i] << ", " << endl;
	}
	cout << endl;
	for (int i = 0; i < right_len; i++)
	{
		cout << right_clique[i] << ", " << endl;
	}
	int c = check_solution();
	cout << "is feasible?: " << c << endl;
	cout << "nb0: " << left_nb0Len << ", " << right_nb0Len << endl;
	for (int i = 0; i < left_nb0Len; i++)
	{
		cout << left_nb0[i] << ", " << left_mapping_len[left_nb0[i]] << ", " << left_nb0_flag[left_nb0[i]] << endl;
	}
	cout << endl;
	for (int i = 0; i < right_nb0Len; i++)
	{
		cout << right_nb0[i] << ", " << right_mapping_len[right_nb0[i]] << ", " << right_nb1_flag[right_nb1[i]] << endl;
	}
	cout << "nb1: " << left_nb1Len << ", " << right_nb1Len << endl;
	for (int i = 0; i < left_nb1Len; i++)
	{
		cout << left_nb1[i] << ", " << left_mapping_len[left_nb1[i]] << ", " << left_nb1_flag[left_nb1[i]] << endl;
	}
	cout << endl;
	for (int i = 0; i < right_nb1Len; i++)
	{
		cout << right_nb1[i] << ", " << right_mapping_len[right_nb1[i]] << ", " << right_nb1_flag[right_nb1[i]] << endl;
	}
}

void report_best()
{
	sort(left_best, left_best + best_value);
	sort(right_best, right_best + best_value);
	for (int i = 0; i < best_value; i++)
	{
		cout << left_best[i] << "(" << left_org_adjlen[left_best[i]] << "), ";
	}
	cout << endl;
	for (int i = 0; i < best_value; i++)
	{
		cout << right_best[i] << "(" << right_org_adjlen[right_best[i]] << "), ";
	}
	cout << "feasible: " << check_solution() << endl;
}

int check_graph()
{
	int left_temp, right_temp, x;
	for (int i = 0; i < left_crt_max_vtx; i++)
	{
		left_temp = left_crt_v_org_id[i];
		for (int j = 0; j < left_crt_adjlen[i]; j++)
		{
			right_temp = right_crt_v_org_id[left_crt_adj[i][j]];
			x = binary_search(left_org_adj[left_temp], left_org_adj[left_temp] + left_org_adjlen[left_temp], right_temp);
			if (!x)
				return 0;
		}

	}
	return 1;
}

void reduce_and_rebuild()
{
	if (best_value >= crt_min_deg)
	{
		vector<int> left_vtx_2_remove;
		vector<int> right_vtx_2_remove;
		//peel graph

		//best_value = 10;
 		find_peel_vertices(best_value, left_vtx_2_remove, right_vtx_2_remove);
		cout<<"iter: "<<iter << ", best_value: " << best_value << ", left reduce size: " << left_vtx_2_remove.size() << ", right reduce size: " << right_vtx_2_remove.size() << endl;
	
		rebuild_rest_graph(left_vtx_2_remove, right_vtx_2_remove);
		cout << "after reduce, left max: " << left_crt_max_vtx << ", right max: " << right_crt_max_vtx << endl;
		//cout << "after reduce, is a right graph: " << check_graph() << endl;


		left_vtx_2_remove.clear();
		right_vtx_2_remove.clear();
		//cout << "left len: " << left_len << ", right len: " << right_len << endl;
		initial_construct();
		
	}
}




int main(int argc, char **argv)
{
	if (argc == 4)
	{
		inFile = argv[1];
		depth = atoi(argv[2]);
		cutting_time = atoi(argv[3]);
	}	
	else
	{
		cout << "Error : the user should input 2 parameters to run the program." << endl;
		getchar();
		exit(0);
	}
	ofstream fout("mbbp_sparse.txt", ios::app);
	if (!fout)
	{
		cout << "can not open output file" << endl;
		return 1;
	}


	srand((unsigned)time(NULL));

	
	cout << inFile << endl;
	read_initial(inFile);

	//initial_construct(); 

	startTime = clock();
	endTime = startTime;

	//cout << "min: " << crt_min_deg << endl;
	

	tabu_search();
	fout << inFile << "	" << best_value << "	" << best_time << endl;


	//getchar();
	return 0;
}